//----------------------------------------------------------------------------
// user_logic.vhd - module
//----------------------------------------------------------------------------
//
// ***************************************************************************
// ** Copyright (c) 1995-2008 Xilinx, Inc.  All rights reserved.            **
// **                                                                       **
// ** Xilinx, Inc.                                                          **
// ** XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"         **
// ** AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND       **
// ** SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,        **
// ** OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,        **
// ** APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION           **
// ** THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,     **
// ** AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE      **
// ** FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY              **
// ** WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE               **
// ** IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR        **
// ** REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF       **
// ** INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS       **
// ** FOR A PARTICULAR PURPOSE.                                             **
// **                                                                       **
// ***************************************************************************
//
//----------------------------------------------------------------------------
// Filename:          user_logic.vhd
// Version:           1.00.a
// Description:       User logic module.
// Date:              Mon Mar 23 15:09:48 2009 (by Create and Import Peripheral Wizard)
// Verilog Standard:  Verilog-2001
//----------------------------------------------------------------------------


module user_logic
(
  // -- ADD USER PORTS BELOW THIS LINE ---------------
	// control signals
	buf_address, 		//the current pixel that is required by ip_to_mem		
	buf_read_data, 		// the data to send to ip_to_mem
	buf_pixel_count, 	//current video input pixel_count
	buf_line_count, 	//current video input line_count
	buf_read_enable, 	//buf 0 read enable
	buf_write_enable, 	//buf 0 write enable
  // -- ADD USER PORTS ABOVE THIS LINE ---------------

  // -- DO NOT EDIT BELOW THIS LINE ------------------
  // -- Bus protocol ports, do not add to or delete 
  Bus2IP_Clk,                     // Bus to IP clock
  Bus2IP_Reset,                   // Bus to IP reset
  Bus2IP_Data,                    // Bus to IP data bus
  Bus2IP_BE,                      // Bus to IP byte enables
  Bus2IP_RdCE,                    // Bus to IP read chip enable
  Bus2IP_WrCE,                    // Bus to IP write chip enable
  IP2Bus_Data,                    // IP to Bus data bus
  IP2Bus_RdAck,                   // IP to Bus read transfer acknowledgement
  IP2Bus_WrAck,                   // IP to Bus write transfer acknowledgement
  IP2Bus_Error,                   // IP to Bus error response
  IP2Bus_MstRd_Req,               // IP to Bus master read request
  IP2Bus_MstWr_Req,               // IP to Bus master write request
  IP2Bus_Mst_Addr,                // IP to Bus master address bus
  IP2Bus_Mst_BE,                  // IP to Bus master byte enables
  IP2Bus_Mst_Length,              // IP to Bus master transfer length
  IP2Bus_Mst_Type,                // IP to Bus master transfer type
  IP2Bus_Mst_Lock,                // IP to Bus master lock
  IP2Bus_Mst_Reset,               // IP to Bus master reset
  Bus2IP_Mst_CmdAck,              // Bus to IP master command acknowledgement
  Bus2IP_Mst_Cmplt,               // Bus to IP master transfer completion
  Bus2IP_Mst_Error,               // Bus to IP master error response
  Bus2IP_Mst_Rearbitrate,         // Bus to IP master re-arbitrate
  Bus2IP_Mst_Cmd_Timeout,         // Bus to IP master command timeout
  Bus2IP_MstRd_d,                 // Bus to IP master read data bus
  Bus2IP_MstRd_rem,               // Bus to IP master read remainder
  Bus2IP_MstRd_sof_n,             // Bus to IP master read start of frame
  Bus2IP_MstRd_eof_n,             // Bus to IP master read end of frame
  Bus2IP_MstRd_src_rdy_n,         // Bus to IP master read source ready
  Bus2IP_MstRd_src_dsc_n,         // Bus to IP master read source discontinue
  IP2Bus_MstRd_dst_rdy_n,         // IP to Bus master read destination ready
  IP2Bus_MstRd_dst_dsc_n,         // IP to Bus master read destination discontinue
  IP2Bus_MstWr_d,                 // IP to Bus master write data bus
  IP2Bus_MstWr_rem,               // IP to Bus master write remainder
  IP2Bus_MstWr_sof_n,             // IP to Bus master write start of frame
  IP2Bus_MstWr_eof_n,             // IP to Bus master write end of frame
  IP2Bus_MstWr_src_rdy_n,         // IP to Bus master write source ready
  IP2Bus_MstWr_src_dsc_n,         // IP to Bus master write source discontinue
  Bus2IP_MstWr_dst_rdy_n,         // Bus to IP master write destination ready
  Bus2IP_MstWr_dst_dsc_n          // Bus to IP master write destination discontinue
  // -- DO NOT EDIT ABOVE THIS LINE ------------------
); // user_logic

// -- ADD USER PARAMETERS BELOW THIS LINE ------------
// --USER parameters added here 
// -- ADD USER PARAMETERS ABOVE THIS LINE ------------

// -- DO NOT EDIT BELOW THIS LINE --------------------
// -- Bus protocol parameters, do not add to or delete
parameter C_SLV_DWIDTH                   = 32;
parameter C_MST_AWIDTH                   = 32;
parameter C_MST_DWIDTH                   = 32;
parameter C_NUM_REG                      = 4;
// -- DO NOT EDIT ABOVE THIS LINE --------------------

// -- ADD USER PORTS BELOW THIS LINE -----------------
// --USER ports added here 
// -- ADD USER PORTS ABOVE THIS LINE -----------------

// -- DO NOT EDIT BELOW THIS LINE --------------------
// -- Bus protocol ports, do not add to or delete
input                                     Bus2IP_Clk;
input                                     Bus2IP_Reset;
input      [0 : C_SLV_DWIDTH-1]           Bus2IP_Data;
input      [0 : C_SLV_DWIDTH/8-1]         Bus2IP_BE;
input      [0 : C_NUM_REG-1]              Bus2IP_RdCE;
input      [0 : C_NUM_REG-1]              Bus2IP_WrCE;
output     [0 : C_SLV_DWIDTH-1]           IP2Bus_Data;
output                                    IP2Bus_RdAck;
output                                    IP2Bus_WrAck;
output                                    IP2Bus_Error;
output                                    IP2Bus_MstRd_Req;
output                                    IP2Bus_MstWr_Req;
output     [0 : C_MST_AWIDTH-1]           IP2Bus_Mst_Addr;
output     [0 : C_MST_DWIDTH/8-1]         IP2Bus_Mst_BE;
output     [0 : 11]                       IP2Bus_Mst_Length;
output                                    IP2Bus_Mst_Type;
output                                    IP2Bus_Mst_Lock;
output                                    IP2Bus_Mst_Reset;
input                                     Bus2IP_Mst_CmdAck;
input                                     Bus2IP_Mst_Cmplt;
input                                     Bus2IP_Mst_Error;
input                                     Bus2IP_Mst_Rearbitrate;
input                                     Bus2IP_Mst_Cmd_Timeout;
input      [0 : C_MST_DWIDTH-1]           Bus2IP_MstRd_d;
input      [0 : C_MST_DWIDTH/8-1]         Bus2IP_MstRd_rem;
input                                     Bus2IP_MstRd_sof_n;
input                                     Bus2IP_MstRd_eof_n;
input                                     Bus2IP_MstRd_src_rdy_n;
input                                     Bus2IP_MstRd_src_dsc_n;
output                                    IP2Bus_MstRd_dst_rdy_n;
output                                    IP2Bus_MstRd_dst_dsc_n;
output     [0 : C_MST_DWIDTH-1]           IP2Bus_MstWr_d;
output     [0 : C_MST_DWIDTH/8-1]         IP2Bus_MstWr_rem;
output                                    IP2Bus_MstWr_sof_n;
output                                    IP2Bus_MstWr_eof_n;
output                                    IP2Bus_MstWr_src_rdy_n;
output                                    IP2Bus_MstWr_src_dsc_n;
input                                     Bus2IP_MstWr_dst_rdy_n;
input                                     Bus2IP_MstWr_dst_dsc_n;
// -- DO NOT EDIT ABOVE THIS LINE --------------------

// control lines, functionality described in port list
input [10:0]	buf_address; 				
output [0:31]	buf_read_data; 
input  [10:0]   buf_pixel_count; 
input   [9:0] buf_line_count; 
input	buf_read_enable;		
input	buf_write_enable; 

	//bus control registers
   reg REG_IP2Bus_MstWr_Req; 
   reg REG_IP2Bus_MstRd_Req; 
   reg REG_IP2Bus_MstWr_sof_n; 
   reg REG_IP2Bus_MstWr_eof_n;
   reg REG_IP2Bus_Mst_Type; 
   reg REG_IP2Bus_MstRd_dst_dsc_n; 
   reg REG_IP2Bus_MstRd_dst_rdy_n; 
   reg REG_IP2Bus_MstWr_src_dsc_n; 
   reg REG_IP2Bus_MstWr_src_rdy_n; 
   reg [0:31] REG_Bus2IP_MstRd_d; 
   reg [31:0] REG_IP2Bus_Mst_Addr; 
   reg REG_IP2Bus_Mst_Reset;
   
   //current place in the buffer we are writing to
   reg [15:0] my_write_index; 
   //current address we're reading from
   wire [31:0] Addr_counter;
   
   // RGB values going into ip_to_mem block
   reg [7:0] my_read_red; 
   reg [7:0] my_read_green; 
   reg [7:0] my_read_blue; 
   
   // RGB values from buffer 0
   wire [7:0] my_read_red0; 
   wire [7:0] my_read_green0; 
   wire [7:0] my_read_blue0; 
   
   //RGB values from buffer 1
   wire [7:0] my_read_red1; 
   wire [7:0] my_read_green1; 
   wire [7:0] my_read_blue1; 
   
   //RGB values read from memory
   wire [7:0] my_write_red; 
   wire [7:0] my_write_green; 
   wire [7:0] my_write_blue; 
   
   //RGB word read from memory
   reg [0:31] mem_read_data; 
   
   // Burst Read state machine
   parameter [2:0]
		str_read = 0, 
		set_read = 1, 
		ack_state_read = 2, 
		cmp_read = 3,
		st1_read = 4;

	reg [2:0] y; 
	reg [2:0] Y; 
//----------------------------------------------------------------------------
// Implementation
//----------------------------------------------------------------------------

  // --USER nets declarations added here, as needed for user logic

  // --USER logic implementation added here

  // ------------------------------------------------------------
  // Example code to drive IP to Bus signals
  // ------------------------------------------------------------


  // assign the RGB word going into the ip_to_mem module
  assign buf_read_data[0] = 0;
  assign buf_read_data[1] = 0;
  assign buf_read_data[2] = 0;
  assign buf_read_data[3] = 0;
  assign buf_read_data[4] = 0;
  assign buf_read_data[5] = 0;
  assign buf_read_data[6] = 0;
  assign buf_read_data[7] = 0;
  assign buf_read_data[8] = my_read_red[7];
  assign buf_read_data[9] = my_read_red[6];
  assign buf_read_data[10] = my_read_red[5]; 
  assign buf_read_data[11] = my_read_red[4]; 
  assign buf_read_data[12] = my_read_red[3]; 
  assign buf_read_data[13] = my_read_red[2]; 
  assign buf_read_data[14] = 0;
  assign buf_read_data[15] = 0;
  assign buf_read_data[16] = my_read_green[7];
  assign buf_read_data[17] = my_read_green[6];
  assign buf_read_data[18] = my_read_green[5];
  assign buf_read_data[19] = my_read_green[4];
  assign buf_read_data[20] = my_read_green[3];
  assign buf_read_data[21] = my_read_green[2];
  assign buf_read_data[22] = 0;
  assign buf_read_data[23] = 0;
  assign buf_read_data[24] = my_read_blue[7];
  assign buf_read_data[25] = my_read_blue[6];
  assign buf_read_data[26] = my_read_blue[5];
  assign buf_read_data[27] = my_read_blue[4];
  assign buf_read_data[28] = my_read_blue[3];
  assign buf_read_data[29] = my_read_blue[2];
  assign buf_read_data[30] = 0;
  assign buf_read_data[31] = 0;
  
  //assign the R, G, B registers from the word we get from memory
  assign my_write_red[7] = mem_read_data[8]; 
  assign my_write_red[6] = mem_read_data[9]; 
  assign my_write_red[5] = mem_read_data[10]; 
  assign my_write_red[4] = mem_read_data[11]; 
  assign my_write_red[3] = mem_read_data[12]; 
  assign my_write_red[2] = mem_read_data[13]; 
  
  assign my_write_green[7] = mem_read_data[16]; 
  assign my_write_green[6] = mem_read_data[17]; 
  assign my_write_green[5] = mem_read_data[18]; 
  assign my_write_green[4] = mem_read_data[19]; 
  assign my_write_green[3] = mem_read_data[20]; 
  assign my_write_green[2] = mem_read_data[21]; 
  
  
  assign my_write_blue[7] = mem_read_data[24]; 
  assign my_write_blue[6] = mem_read_data[25]; 
  assign my_write_blue[5] = mem_read_data[26]; 
  assign my_write_blue[4] = mem_read_data[27]; 
  assign my_write_blue[3] = mem_read_data[28]; 
  assign my_write_blue[2] = mem_read_data[29]; 
  
  // Assign PLB control signals
  assign IP2Bus_Mst_Type = REG_IP2Bus_Mst_Type;
  assign IP2Bus_MstRd_Req = REG_IP2Bus_MstRd_Req;
  assign IP2Bus_MstRd_dst_dsc_n = REG_IP2Bus_MstRd_dst_dsc_n;
  assign IP2Bus_MstRd_dst_rdy_n = REG_IP2Bus_MstRd_dst_rdy_n;
  assign IP2Bus_MstWr_Req = REG_IP2Bus_MstWr_Req;
  assign IP2Bus_MstWr_sof_n = REG_IP2Bus_MstWr_sof_n;
  assign IP2Bus_MstWr_eof_n = REG_IP2Bus_MstWr_eof_n;
  assign IP2Bus_MstWr_src_rdy_n = REG_IP2Bus_MstWr_src_rdy_n;
  assign IP2Bus_MstWr_src_dsc_n = REG_IP2Bus_MstWr_src_dsc_n;	
 
  assign IP2Bus_Mst_Addr 			=  REG_IP2Bus_Mst_Addr;  
  assign IP2Bus_Mst_Reset = REG_IP2Bus_Mst_Reset;
  
  
  assign IP2Bus_Mst_Lock = 0;
  
  assign IP2Bus_MstWr_rem 		    = 4'b0000; 
  assign IP2Bus_Mst_Length  	    = 12'hc80; 
  assign IP2Bus_Mst_BE              = 4'b1111;    

  assign IP2Bus_Data = 0;              // IP to Bus data bus
  assign IP2Bus_RdAck = 0;                  // IP to Bus read transfer acknowledgement
  assign IP2Bus_WrAck  = 0;                 // IP to Bus write transfer acknowledgement
  assign IP2Bus_Error  = 0;                 // IP to Bus error response  
  
  // current address we're reading from
  //4096 is the size of each line in bytes
  assign Addr_counter = 32'h90000000 + 4096 * buf_line_count;
  
  always @(*)
  begin
	   case(y)
		//waits for a new line from the input
		str_read:
			begin
					//if we're about to start a new line, go to the next state
					if (buf_pixel_count == 0)
						Y = set_read; 
					else 
						Y = str_read; 
			end
	   //request a burst read
	   set_read:
			begin
				// wait for the bust to acknowledge the burst read
				if (Bus2IP_Mst_CmdAck == 1 && Bus2IP_MstRd_sof_n == 0)
					Y = cmp_read; 
				else if (Bus2IP_Mst_CmdAck == 1)
					Y = ack_state_read; 
				else
					Y = set_read; 
			end
		// wait for the data to be put on the bus
	   ack_state_read:
			begin
				if (Bus2IP_MstRd_sof_n == 0)
					Y = cmp_read; 
				else
					Y = ack_state_read; 
			end
		// once the data is on the bus, read it in until the bus sends the eof signal
	   cmp_read:
			begin
				if (Bus2IP_MstRd_eof_n == 0)
					Y = st1_read; 
				else
					Y = cmp_read; 
			end
		// reset the read, and go to the next line
	   st1_read: 
			begin
				Y = str_read; 
			end
			
		default: Y = str_read;
		endcase
   end  	
	 

  always @ (posedge Bus2IP_Clk or posedge Bus2IP_Reset)
  begin
	if (Bus2IP_Reset == 1)
		begin 
			// init state machine / signals
			y <= str_read;
			my_write_index <= 0; 
		end
	else
		begin
			// when we are on a new line, reset the buffer write index
			if (y == str_read)
			begin
				my_write_index <= 0; 
			end
			
			// when the bus is ready to send data, read in the data, and increment the current read pixel counter
			if (Bus2IP_MstRd_src_rdy_n == 0)
			begin
				mem_read_data <= Bus2IP_MstRd_d; 
				my_write_index <= my_write_index + 1; 
			end

			// go to the next state
			y <= Y;
		end
  end
  
  // PLB CONTROL SIGNALS FOR THE BURST READ
  always@(y)
  begin 
	  case(y)
	 // burst read
	  str_read: begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 0; 
			  REG_IP2Bus_Mst_Reset = 0;
			  REG_IP2Bus_MstRd_Req = 0; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 1; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1; 
			end
	   set_read: begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 1; 
			  REG_IP2Bus_Mst_Reset = 0;
			  REG_IP2Bus_MstRd_Req = 1; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 0; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1; 
			end
	   ack_state_read: begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 1; 
			  REG_IP2Bus_Mst_Reset = 0;
			  REG_IP2Bus_MstRd_Req = 0; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 0; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1; 
			end
	   cmp_read: begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 1; 
			  REG_IP2Bus_Mst_Reset = 0;
			  REG_IP2Bus_MstRd_Req = 0; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 0; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1; 
			end
		st1_read: begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 1; 
			  REG_IP2Bus_Mst_Reset = 1;
			  REG_IP2Bus_MstRd_Req = 0; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 1; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1; 
			end
	  default:
		begin
              REG_IP2Bus_MstWr_sof_n = 1; 
              REG_IP2Bus_MstWr_eof_n = 1;
			  REG_IP2Bus_MstWr_Req = 0; 
			  REG_IP2Bus_Mst_Type = 0; 
			  REG_IP2Bus_Mst_Reset= 0;
			  REG_IP2Bus_MstRd_Req = 0; 
			  //here we make sure to be reading the next line to the one that is being streamed from video
			  // the 0x300000 offset selects the still frame in memory, and the 0x9000 offset selects the next line. 
			  REG_IP2Bus_Mst_Addr = Addr_counter + 32'h00301000; 
			  REG_IP2Bus_MstRd_dst_dsc_n = 1; 
			  REG_IP2Bus_MstRd_dst_rdy_n = 1; 
			  REG_IP2Bus_MstWr_src_dsc_n = 1; 
			  REG_IP2Bus_MstWr_src_rdy_n = 1;
			end
	  endcase 
  end   
  
	// decide from which buffer we're reading, based on the read enable signal from ip_to_mem block
  	always @ (posedge Bus2IP_Clk or posedge Bus2IP_Reset) begin
		if (Bus2IP_Reset ) begin
				my_read_red[7:0] <= 8'h00;
				my_read_green[7:0] <= 8'h00;
				my_read_blue[7:0] <= 8'h00;
				end
		else if (buf_read_enable) begin
				my_read_red[7:0] <= my_read_red0[7:0];
				my_read_green[7:0] <= my_read_green0[7:0];
				my_read_blue[7:0] <= my_read_blue0[7:0];
				end
		else begin
				my_read_red[7:0] <= my_read_red1[7:0];
				my_read_green[7:0] <= my_read_green1[7:0];
				my_read_blue[7:0] <= my_read_blue1[7:0];
				end

		end
		
	// TWO READ LINE BUFFERS
  	LINE_BUFFER LBRead0
	(
	.read_clk         (Bus2IP_Clk),
	.read_address     (buf_address + 2), //+2 offset used for allignment
	.read_enable      (1),
	.read_red_data    (my_read_red0),
	.read_green_data  (my_read_green0),
	.read_blue_data   (my_read_blue0),

	.write_clk        (Bus2IP_Clk),
	.write_address    (my_write_index),
	.write_enable     (buf_write_enable),
	.write_red_data   (my_write_red),
	.write_green_data (my_write_green),
	.write_blue_data  (my_write_blue)
	);
	
	LINE_BUFFER LBRead1
	(
	.read_clk         (Bus2IP_Clk),
	.read_address     (buf_address + 2), //+2 offset used for allignment
	.read_enable      (1),
	.read_red_data    (my_read_red1),
	.read_green_data  (my_read_green1),
	.read_blue_data   (my_read_blue1),

	.write_clk        (Bus2IP_Clk),
	.write_address    (my_write_index),
	.write_enable     (~buf_write_enable),
	.write_red_data   (my_write_red),
	.write_green_data (my_write_green),
	.write_blue_data  (my_write_blue)
	);
endmodule
