//Name: Ian Katsuno
//Student #: 995614571
//Course: ECE532
//Date: Feb 9, 2011

/***************************** Include Files *********************************/

#include "xparameters.h"    /* generated system parameters                  */
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xps2.h"     /* layer 1 timer counter device driver          */
#include "xintc.h"
#include <xiic_l.h>


#define GPO_REG_OFFSET 0x124
#define DECODER_ADDR 0x20 //Read: 0x41, Write: 0x40
#define SEND_CNT 3
#define RECV_CNT 3
#define GPO_RESETS_OFF 1
#define GPO_RESET_IIC 3
#define GPO_RESET_DECODER 0

struct VideoModule {
  Xuint8 addr;
  Xuint8 config_val;
  Xuint8 actual_val;
};


//Composite Configuration constants
#define DECODER_COMP_CONFIG_CNT 18
struct VideoModule decoder_comp[] = { 
  { 0x00, 0x04, 0 },
  { 0x15, 0x00, 0 },
  { 0x17, 0x41, 0 },
  { 0x27, 0x58, 0 },
  { 0x3a, 0x16, 0 }, 
  { 0x50, 0x04, 0 },
  { 0x0e, 0x80, 0 },
  { 0x50, 0x20, 0 },
  { 0x52, 0x18, 0 }, 
  { 0x58, 0xed, 0 },
  { 0x77, 0xc5, 0 },
  { 0x7c, 0x93, 0 },
  { 0x7d, 0x00, 0 },
  { 0xd0, 0x48, 0 },
  { 0xd5, 0xa0, 0 },
  { 0xd7, 0xea, 0 },
  { 0xe4, 0x3e, 0 },
  { 0xea, 0x0f, 0 }, 
  { 0x0e, 0x00, 0 } };


void configDecoder(struct VideoModule *decoder, int config_cnt );


/************************** Constant Definitions *****************************/
#define left_button_mask 0x1
#define printf xil_printf
#define LEFT_CLICK 0x1
#define RIGHT_CLICK 0x2
#define X_DIRECTION 0x16 //a 1 in x or y direction bit means negative
#define Y_DIRECTION 0x32
/************************** Function Prototypes ******************************/

void PS2Handler(void *CallBackRef, u32 IntrMask, u32 ByteCount);
void PS2_Callback();


/************************** Variable Definitions *****************************/

/* The following data is declared globally such that it is easily accessible
 * from anywhere within the program. Note that it is important that these 
 * variables be zeroed no matter where they are declared because the functions
 * that perform initialization for device drivers will indicate errors if they
 * are not initialized.
 */
//XIntc InterruptController; //interrupt controller instance
XPs2 ps2; //PS2 instance		
XIntc InterruptController;
char Value1[50];
char Value2[50];
char Value3[50];
char Value[50];
int i;
int full;
int interrupt_reason[50];
int numBytesRecieved;
int x = 320;
int y = 240;
int click;

#define blue 	0x3F000000
#define green 	0x003F0000
#define red		0x00003F00
#define white  0x3F3F3F00
#define black 	0x00000000

struct Screen
{
	unsigned int pixel_data[491520];
};

//Writes the given pixel value to the given screen at the given x-y location
void write_pixel(struct Screen* in, unsigned int value, unsigned int x, unsigned int y)
{
	in->pixel_data[(y * 1024) + x] = value;
}

//Writes the given RGB pixel value to the given screen at the given x-y location
void write_pixel_rgb(struct Screen* in, unsigned int R, unsigned int G, unsigned int B, unsigned int x, unsigned int y)
{
		in->pixel_data[(y * 1024) + x] = (R * 65536) + (G * 256) + B;
}


void draw_box(struct Screen* s,unsigned int color,unsigned int x, unsigned int dx, unsigned int y, unsigned int dy)
{
	int i,j;
	for (i=x; i<x+dx; i++){
		for (j=y; j<y+dy; j++){
			write_pixel(s,color,i,j);
		}
	}
}

struct Screen *s;

int main_draw_mouse()
{
	s = (struct Screen *) (XPAR_DDR_SDRAM_MPMC_BASEADDR);
	draw_box(s, black, 0, 640, 0, 480);
	draw_box(s,white, 200, 50, 200, 50);

		
	full = 0;
	XPs2_Config *ps2Config;
	ps2Config = XPs2_LookupConfig(XPAR_XPS_PS2_0_0_DEVICE_ID);
	
	XStatus Status;
	Status = XPs2_CfgInitialize(&ps2, ps2Config, XPAR_XPS_PS2_0_0_BASEADDR);
	if(Status==XST_SUCCESS) 
		printf("\n\rPS2 initalized successfully\n\r");
	else
		printf("\n\rPS2 not initialized successfully\n\r");

	Status = XPs2_SelfTest(&ps2);
	if(Status==XST_SUCCESS) 
		printf("ps2 self test successful\n\r");
	else
		printf("ps2 seft test not successful\n\r");
	
	XPs2_SetHandler  (&ps2, &PS2Handler,  
			&PS2_Callback);  

	
	
	
	/********************** Interrupt Controller Setup *********************/  
    /*
     * Initialize the interrupt controller driver so that it's ready to use,
     * using the device ID that is generated in xparameters.h
     */
    Status = XIntc_Initialize(&InterruptController, XPAR_XPS_INTC_0_DEVICE_ID);
    if (Status != XST_SUCCESS)
    {
        printf("Interrupt controller initialization error\n\r");
    } 

    /*
     * Connect the device driver handler that will be called when an interrupt
     * for the device occurs, the device driver handler performs the specific
     * interrupt processing for the device
     */
    Status = XIntc_Connect(&InterruptController,
                           XPAR_INTC_0_PS2_0_VEC_ID,
                           (XInterruptHandler)XPs2_IntrHandler,
                           &ps2);
    if (Status != XST_SUCCESS)
        printf("Interrupt controller connect error\n\r");


	//SENDING RESET CODE
	char PS2reset = 0xFF;
	xil_printf("\n\rsending reset code 0xff to mouse\n\r");
	int num_bytes_sent = XPs2_Send(&ps2,  &PS2reset, 1)   ;
	if(num_bytes_sent == 1)
			xil_printf("\n\rreset code sent successfully\n\r");
	else
		xil_printf("\n\rreset code NOT sent successfully\n\r");
	
	//RECEIVE ACKNOWLEDGE FOR RESET CODE
	char PS2Acknowledge = 0xFA;
	char recieved_Char=0x00;
	int num_bytes_rec=0;
	//SPINNING WAITING FOR ACKNOWLEDGE
	while(recieved_Char!=-6)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &recieved_Char, 1);
		//printf("%x \n\r", recieved_Char);
	}
	if((num_bytes_rec == 1)&&(recieved_Char==PS2Acknowledge))
			xil_printf("\n\rAcknowledge code recieved successfully\n\r");
	else
		xil_printf("\n\rAcknowledge code NOT recieved successfully\n\r");

	//SPINNING WAITING FOR SELFTEST PASS
	char PS2mouse_self_test = 0xAA;
	while(recieved_Char==-6)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &recieved_Char, 1);
		//printf("%x \n\r", recieved_Char);
	}	
	if((num_bytes_rec == 1)&&(recieved_Char==PS2mouse_self_test))
			xil_printf("\n\rself-test code recieved successfully\n\r");
	else
		xil_printf("\n\r self test code NOT recieved successfully\n\r");

	//SPINNING WAITING FOR DEVICE ID
	for(i=0; i<100;i++)
	{
	
		if(recieved_Char==0x00)
			break;
		num_bytes_rec = XPs2_Recv(&ps2, &recieved_Char, 1);
		//printf("%x \n\r", recieved_Char);
	}	
	if((num_bytes_rec == 1)&&(recieved_Char==PS2mouse_self_test))
			xil_printf("\n\rself-test code recieved successfully\n\r");
	else
		xil_printf("\n\r self test code NOT recieved successfully\n\r");

	//REQUESTING DEVICE ID
	char PS2_device_read = 0xF2;
	printf("Requesting Device ID \n\r");
	num_bytes_sent = XPs2_Send(&ps2, &PS2_device_read, 1);
	char PS2_device_type;
	num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_type, 1);
	printf("%x\n", PS2_device_type, 1);

   for(i = 0; i<10; i++)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_type, 1);
		//printf("%x\n\r", PS2_device_type, 1);
	}

	//REQUESTING DEVICE STATUS
	char PS2_status_request = 0xe9;
	printf("Requesting Device Status \n\r");
	num_bytes_sent = XPs2_Send(&ps2, &PS2_status_request, 1);
	char PS2_device_status;
	num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_status, 1);
	printf("%x\n", PS2_device_status, 1);

   for(i = 0; i<10; i++)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_type, 1);
		//printf("%x\n\r", PS2_device_type, 1);
	}

	//SETTING MOUSE TO STREAM MODE
	char STREAM_MODE = 0xea;
	num_bytes_sent = XPs2_Send(&ps2, &STREAM_MODE, 1);
	num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_status, 1);

	//ENABLING DATA REPORTING IN STREAM MODE
	char PS2mouse_enable_data_reporting = 0xF4;
	num_bytes_sent = XPs2_Send(&ps2, &PS2mouse_enable_data_reporting, 1);
	if(num_bytes_sent ==1)
		printf("enable data reporting code sent successfully\n\r");
	else
		printf("enable data reporting code NOT sent successfully\n\r");

   for(i = 0; i<10; i++)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_type, 1);
		//printf("%x\n\r", PS2_device_type, 1);
	}

	//ENABLING INTERRUPTS
	 
	 printf("enabling Xintc interrupts.. \n\r");
    XIntc_Enable(&InterruptController,
                 XPAR_INTC_0_PS2_0_VEC_ID);
					  
	 printf("enabling microblaze interrupts.. \n\r");
    microblaze_enable_interrupts(); 

    /*
     * Start the interrupt controller so interrupts are enabled for all
     * devices that cause interrupts. Specify real mode so that the timer
     * counter can cause interrupts through the interrupt controller.
     */
    Status = XIntc_Start(&InterruptController, XIN_REAL_MODE);
    if (Status != XST_SUCCESS)
        printf("Interrupt controller start error\n\r");
	 printf("enabling ps2 interrupts \n\r");
	 XPs2_IntrEnable  (&ps2, XPS2_IPIXR_RX_ALL|XPS2_IPIXR_TX_ALL);   
	 XPs2_IntrGlobalEnable  (&ps2);   


	printf("Requesting Device Status \n\r");
	num_bytes_sent = XPs2_Send(&ps2, &PS2_status_request, 1);
	num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_status, 1);
	printf("%x\n", PS2_device_status, 1);

	
	printf("Requesting Device Status \n\r");
	num_bytes_sent = XPs2_Send(&ps2, &PS2_status_request, 1);
	num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_status, 1);
	printf("%x\n", PS2_device_status, 1);

   for(i = 0; i<9; i++)
	{
		num_bytes_rec = XPs2_Recv(&ps2, &PS2_device_type, 1);
		//printf("%x\n\r", PS2_device_type, 1);
	} 
	   
		
	printf("entering while loop\n\r");
		XPs2_IntrClear(&ps2, 1);

	while(1)
	{
		//numBytesRecieved = XPs2_Recv(&ps2, Value, 3);	
		if(x > 640)
			x = 640;
		if(x < 0)
			x = 0;
		if(y > 480)
			y = 480;
		if(y < 0)
			y = 0;
		draw_box(s,red,x,5,y,5);
		if(click)
			draw_box(s,green,x-20,40,y-20,40);
		//if(( x > 200 ) && ( x < 250) && (y > 200) && (y < 250) && (click))	
		//	draw_box(s, black, 200, 50, 200, 50);
	}	

	XPs2_IntrGlobalDisable(&ps2);
	
	XPs2_IntrDisable(&ps2, XPS2_IPIXR_RX_ALL|XPS2_IPIXR_TX_ALL);
	/*int h;
	for(h=0; h< 50;h++)
	{
			if(Value3[h]&LEFT_CLICK)
				printf("L\t");
			if(Value3[h]&RIGHT_CLICK)
				printf("R\t");
			printf("%d, %d, %d, %d \n\r", interrupt_reason[h], click, x, y);

	}*/
    printf("Exiting the Application\n\r");
}

void PS2Handler(void *CallBackRef, u32 IntrMask, u32 ByteCount)
{
	//XPs2_IntrGlobalDisable(&ps2);
	
	//XPs2_IntrDisable(&ps2, XPS2_IPIXR_RX_ALL|XPS2_IPIXR_TX_ALL);
	//XPs2_IntrClear(&ps2, 1);
	//printf("got into interrupt handler ");
	//printf(" byte count %d \n\r" , ByteCount);
	int num_bytes_rec;
	if(IntrMask&XPS2_IPIXR_RX_FULL)
	{		
		numBytesRecieved = XPs2_Recv(&ps2, Value, 3);		
		full = full + 1;
		interrupt_reason[i] = 11;
		//Value1[i] = Value[0];
		//Value2[i] = Value[1];
		//Value3[i] = Value[2];
		draw_box(s,black,x-10,20,y-10,20);
		x = x + Value[0];
		y = y - Value[1];	
		click = (Value[2]&LEFT_CLICK) | (Value[2]&RIGHT_CLICK);
		//draw_box(s,red,x,5,y,5);
		i++;
		//printf(" Value %d %d %d \n\r" , Value[0], Value[1], Value[2]);
	}

	else if(IntrMask&XPS2_IPIXR_RX_ERR)
	{
		printf("because of RX error\n\r");
	}
	else if(IntrMask&XPS2_IPIXR_RX_OVF)
	{
		numBytesRecieved = XPs2_Recv(&ps2, Value, 3);		
		full = full + 1;
		interrupt_reason[i] = 22;
		//Value1[i] = Value[0];
		//Value2[i] = Value[1];
		//Value3[i] = Value[2];
		draw_box(s,black,x - 10,20,y-10,20);

		x = x + Value[0];
		y = y - Value[1];	
		click = (Value[2]&LEFT_CLICK) | (Value[2]&RIGHT_CLICK);
		//draw_box(s,green,x,5,y,5);
		i++;
		//printf(" Value OVR %d %d %d \n\r" , Value[0], Value[1], Value[2]);
		//XPs2_Reset(&ps2);
	}

		/*printf("%d \t", (int)(recBuf[0]));
		printf("%d \t", (int)(recBuf[1]));
		printf("%d \t", (int)(recBuf[2]));*/
	else if(IntrMask&XPS2_IPIXR_TX_ACK)
	{
		printf("because of TX Acknowledge\n\r");
	}
	else if(IntrMask&XPS2_IPIXR_TX_NOACK)
	{
		printf("because of no TX Acknowledge\n\r");
	}
	
	//char recBuf[3];
	//if(IntrMask&XPS2_IPIXR_RX_FULL)
	//	printf("interrupt because of RX FULL\n\r");
	//int num_bytes_rec = XPs2_Recv(&ps2, recBuf, 3);
	//printf("%x\n", recBuf[0]); 
	//printf("%x\n", recBuf[1]);
	//printf("%x\n", recBuf[2]);
	//XPs2_IntrEnable(&ps2, XPS2_IPIXR_RX_ALL|XPS2_IPIXR_TX_ALL);
	//XPs2_IntrGlobalEnable(&ps2);
}

void PS2_Callback()
{
	printf("callback\n\r");
}


int main() 
{
	Xuint8 start_addr = 0;
	Xuint8 send_data[SEND_CNT] = {0};
	Xuint32 send_cnt;
	Xuint8 recv_data[RECV_CNT] = {0};
	Xuint32 recv_cnt;
	Xuint8 i;

   recv_cnt = 0;
	
	print("\r\nBeginning Setup\r\n");
	configDecoder(decoder_comp, DECODER_COMP_CONFIG_CNT);
	print("\r\nSetup Complete!\r\n\r\n");
   main_draw_mouse();	
} 


void configDecoder(struct VideoModule *decoder, int config_cnt ) 
{
  Xuint16 send_cnt, i;
  Xuint8 send_data[2] = {0};
  Xuint8 success = 1;
  send_cnt = 2;
  xil_printf("  Configuring Decoder...\t");
  //read in configuration constants and send them to the VDEC one by one
  for( i = 0; i < config_cnt; i++ )
   {

    send_data[0] = decoder[i].addr;

    send_data[1] = decoder[i].config_val;

    send_cnt = XIic_Send(XPAR_IIC_BASEADDR, DECODER_ADDR, send_data, 2,XIIC_STOP );

    if( send_cnt != 2 ) 
	 {
      xil_printf("Error writing to address %02x\r\n", decoder[i].addr);
      success = 0;
      break;
     }
   }

  if( success )
    xil_printf("SUCCESS!\r\n");
}
