#include <xbasic_types.h>
#include <xparameters.h>
#include <xiic_l.h>

#define GPO_REG_OFFSET 0x124
#define DECODER_ADDR 0x20 //Read: 0x41, Write: 0x40
#define SEND_CNT 3
#define RECV_CNT 3
#define GPO_RESETS_OFF 1
#define GPO_RESET_IIC 3
#define GPO_RESET_DECODER 0

#define X_MIN 	0xc8c00000
#define X_MAX 	0xc8c00004
#define Y_MIN 	0xc8c00008
#define Y_MAX 	0xc8c0000C
#define CONFIG_ADDR 0x9020d000
#define CONFIG 0x0c0000c0

struct VideoModule {
  Xuint8 addr;
  Xuint8 config_val;
  Xuint8 actual_val;
};


//Composite Configuration constants
#define DECODER_COMP_CONFIG_CNT 18
struct VideoModule decoder_comp[] = { 
  { 0x00, 0x04, 0 },
  { 0x15, 0x00, 0 },
  { 0x17, 0x41, 0 },
  { 0x27, 0x58, 0 },
  { 0x3a, 0x16, 0 }, 
  { 0x50, 0x04, 0 },
  { 0x0e, 0x80, 0 },
  { 0x50, 0x20, 0 },
  { 0x52, 0x18, 0 }, 
  { 0x58, 0xed, 0 },
  { 0x77, 0xc5, 0 },
  { 0x7c, 0x93, 0 },
  { 0x7d, 0x00, 0 },
  { 0xd0, 0x48, 0 },
  { 0xd5, 0xa0, 0 },
  { 0xd7, 0xea, 0 },
  { 0xe4, 0x3e, 0 },
  { 0xea, 0x0f, 0 }, 
  { 0x0e, 0x00, 0 } };


//
// funtion prototypes
//

void configDecoder(struct VideoModule *decoder, int config_cnt );

int main() {

  Xuint8 start_addr = 0;
  Xuint8 send_data[SEND_CNT] = {0};
  Xuint32 send_cnt;
  Xuint8 recv_data[RECV_CNT] = {0};
  Xuint32 recv_cnt;
  Xuint8 i;

	Xuint32 *x_min = (Xuint32*)X_MIN; 
	Xuint32 *x_max = (Xuint32*)X_MAX;
	Xuint32 *y_min = (Xuint32*)Y_MIN; 
	Xuint32 *y_max = (Xuint32*)Y_MAX;
	Xuint32 *config = (Xuint32*)CONFIG_ADDR;

	 // previously used for testing
    recv_cnt = 0;
    recv_cnt = XIic_Recv(XPAR_XPS_IIC_0_BASEADDR, 0,recv_data,1,XIIC_STOP );
	// configure the decoder
	  configDecoder(decoder_comp, DECODER_COMP_CONFIG_CNT);
	 //}
  
  print("\r\nTest Complete!\r\n\r\n");
  
  *config = CONFIG;
  
  while(1){
		xil_printf("x_min = %d, x_max = %d, y_min = %d, y_max = %d             \r", *x_min, *x_max, *y_min, *y_max);
	}
  
  
} // end main()


void configDecoder(struct VideoModule *decoder, int config_cnt ) 
{
  Xuint16 send_cnt, i;
  Xuint8 send_data[2] = {0};
  Xuint8 success = 1;
  send_cnt = 2;
  print("  Configuring Decoder...\t");
  //read in configuration constants and send them to the VDEC one by one
  for( i = 0; i < config_cnt; i++ )
   {

    send_data[0] = decoder[i].addr;

    send_data[1] = decoder[i].config_val;

    send_cnt = XIic_Send(XPAR_XPS_IIC_0_BASEADDR, DECODER_ADDR, send_data, 2,XIIC_STOP );

    if( send_cnt != 2 ) 
	 {
      xil_printf("Error writing to address %02x\r\n", decoder[i].addr);
      success = 0;
      break;
     }
   }

  if( success )
    xil_printf("SUCCESS!\r\n");

}